	; Adventure Vision
	; * Bit-2Xpressor Decompressor
	; | 61 Bytes - Main code
	; |  5 Bytes - Table code
	; by JustBurn, Feb 24 2013

.set	TC_PTR, 22

	; @22 = Table code PC[7~0]
	; @23 = Table code PC[11~8]
	; r6  = Number of bytes
	; r7  = Output address
decompress_bit2xp:
	sel	rb0
	mov	a, psw
	inc	a
	mov	r2, a		; Copy of PSW for restoration
	mov	r1, 30		; User registers start from rb0:r6
	mov	a, @r1
	mov	r6, a		; Get num of packets
	inc	r1
	mov	a, @r1
	mov	r1, a		; Get output address
	clr	a
	mov	r7, a		; index=0
	mov	r5, 7		; inbit=7
decompress_bit2xp_l1:
	call	decompress_bit2xp_readbit
	mov	a, $FF
	jc	decompress_bit2xp_write
	call	decompress_bit2xp_readbit
	clr	a
	jc	decompress_bit2xp_write
	; literal byte
	mov	r4, 8		; bits=8
decompress_bit2xp_l2:
	xch	a, r3
	call	decompress_bit2xp_readbit
	xch	a, r3
	rrc	a
	djnz	r4, decompress_bit2xp_l2
decompress_bit2xp_write:
	movx	@r1, a		; Write byte to output
	inc	r1
	djnz	r6, decompress_bit2xp_l1
	sel	rb1
	ret

decompress_bit2xp_readbit:
	inc	r5		; inbit++
	mov	a, r5
	jb3	decompress_bit2xp_fetch	; if all 8 bits read, fetch new byte
	mov	a, r0
decompress_bit2xp_readbit_shift:
	rrc	a		; data >>= 1
	mov	r0, a
	ret
decompress_bit2xp_fetch:
	clr	a
	mov	psw, a		; stack=0, ret gets stack 7
	mov	a, r7
	inc	r7		; a = index++
	ret			; Read from tc
decompress_bit2xp_return:
	mov	r5, 0		; inbit=0
	xch	a, r2
	mov	psw, a		; Restore PSW
	xch	a, r2
	jmp	decompress_bit2xp_readbit_shift
