; Adventure Vision bnp unpacker v1.01 by MrBlinky, Mar 02 2013

;54 Bytes - bnp unpacker code
; 3 Bytes - required for table code in same 2K bank as unpacker
; 4 bytes - required for table code in upper 2K bank when unpacker is in lower 2K bank

.set	UNPACK_BNP,	1	;signal unpacker already included

.ifndef MC8048
	.equ	STACK,	$08	;defined in MC8048
.endif
	
	;entry:
	;r0=unpack vram address ($06+IMAGE_START)
	;r1=data page 
	;r2=data pointer 	(img_data)
	;r3=data packet count	(IMG_PACKETS)
	;r4=repeat trigger byte (IMG_FLAG)
	
	;used internally:
	;r5,r6, flags f0,f1,c
	
	;unused:
	;r7
	
	;note data must not use not all 256 byte combinations (easy for av as screens are 250 bytes)
	;table code must always be page aligned. (This should be no problem at all)
	
	;prepare stack for farjump (13 bytes)

unpack_bnp:	
	mov	a,psw	
	anl	a,$07		;keep only stack offset
	rl	a		;2 bytes per stack entry
	add	a,STACK+1	;point tp MSB free stack entry
	xch	a,r1		;a=data page, r1=pointer to stack
	mov	@r1,a		;set data page as MSB free stack entry
	dec	r1		;LSB free stack entry
	mov	@r1,0		;set LSB stack entry, table code is always aligned at $x00				
	clr	f0	
	clr	f1		;clear nibble fetch flag
	
	;fetch data (5)
	
unpack_bnp_jmpsp:	
	mov	a,psw		;a=stackpointer
	inc	a		;'stack' table address
	mov	psw,a		;preset it note also clears Cflags (F0 !)
	mov	a,r2		;table data pointer
	ret			;jump to fetch data
	
	;resumed here from fetch data (36 bytes)
	
unpack_bnp_ret:
	inc	r2				;increment data pointer
	jf1	unpack_bnp_nibblesfetched	;f1=1: nibble data fetched do repeat sequence
	xrl	a,r4				;xor with repeat trigger
        jnz     unpack_bnp_notpacked    	;too bad just plain data
		
	;do repeat sequence
	
	jf0	unpack_bnp_highnibble	;unpacking high nibble (2nd pass)
	cpl	f1			;f1=1: fetch nibble data
	jmp	unpack_bnp_jmpsp	;fetch it
	
unpack_bnp_highnibble: 
        mov     a,r5            	;get high repeat nibble
        swap    a               	;into lower nibble
	.db	$BE			;'mov r6,n' to do jmp $+1 to unpack_bnp_lownibble

unpack_bnp_nibblesfetched:	

	cpl	f1			;f1=0: fetch data again
	
	;expand repeated data
	
unpack_bnp_lownibble:	
	cpl	f0			;toggle do high/low nibble
        mov     r5,a            	;save high nibble for 2nd unpack
        rrc     a               	;repeat byte type to carry 0=FF,1=00
        anl     a,$07             	;repeat 0-7 = 2-9 repeats
        inc     a               	;make it 1-8 as the one at unpack_bnp_notpacked is not counted
        mov     r6,a	
        clr     a               	;get repeat byte $00 or $FF
        addc    a,$FF	
unpack_bnp_rep:	
	movx    @r0,a           	;store at vram
        inc     r0	
        djnz    r6,unpack_bnp_rep 	;do n-1 repeats 
	.db	$BE			;'mov r6,n' to do jmp $+1
	
unpack_bnp_notpacked:	
	xrl	a,r4			;restore data value
        movx    @r0,a           	;plain data or one extra repeat byte
        inc     r0			;
        djnz    r3,unpack_bnp_jmpsp   	;unpack next data
        ret
       
;--------------------------------	
