	; Adventure Vision
	; * Flag-RLE Decompressor
	; | 48 Bytes - Main code
	; |  5 Bytes - Table code
	; by JustBurn, Feb 24 2013

.set	TC_PTR, 22

	; @22 = Table code PC[7~0]
	; @23 = Table code PC[11~8]
	; r6  = Number of bytes
	; r7  = Output address
decompress_frle:
	sel	rb0
	mov	a, psw
	inc	a
	mov	r2, a		; Copy of PSW for restoration
	mov	r1, 30		; User registers start from rb0:r4
	mov	a, @r1
	mov	r6, a		; Get num of packets
	inc	r1
	mov	a, @r1
	mov	r1, a		; Get output address
	clr	a
	mov	r7, a		; index=0
	call	decompress_frle_read	; Read flag byte
	mov	r4, a
decompress_frle_l1:
	call	decompress_frle_read	; Read stream
	xrl	a, r4		; if (last == data) repeat
	jz	decompress_frle_repeat
	xrl	a, r4		; Restore byte
	movx	@r1, a		; Write byte to output
	inc	r1
decompress_frle_end:
	djnz	r6, decompress_frle_l1
	sel	rb1
	ret

decompress_frle_repeat:
	call	decompress_frle_read	; Read stream
	mov	r5, a
	call	decompress_frle_read	; Read stream
decompress_frle_l2:
	movx	@r1, a		; Write byte to output
	inc	r1
	djnz	r5, decompress_frle_l2
	djnz	r6, decompress_frle_l1	; This could be replaced by "jmp decompress_frle_end" for -2 space
	sel	rb1
	ret

decompress_frle_read:
	clr	a
	mov	psw, a		; stack=0, ret gets stack 7
	mov	a, r7
	inc	r7		; a = index++
	ret			; Read from tc
decompress_frle_return:
	xch	a, r2
	mov	psw, a		; Restore PSW
	xch	a, r2
	ret
