	; Adventure Vision
	; * sy2002's RLE Decompressor
	; | 56 Bytes - Main code
	; |  5 Bytes - Table code
	; by JustBurn, Feb 24 2013

.set	TC_PTR, 22

	; @22 = Table code PC[7~0]
	; @23 = Table code PC[11~8]
	; r6  = Number of bytes
	; r7  = Output address
decompress_srle:
	sel	rb0
	mov	a, psw
	inc	a
	mov	r2, a		; Copy of PSW for restoration
	mov	r1, 30		; User registers start from rb0:r4
	mov	a, @r1
	mov	r6, a		; Get num of packets
	inc	r1
	mov	a, @r1
	mov	r1, a		; Get output address
	clr	a
	mov	r7, a		; index=0
decompress_srle_l1:
	call	decompress_srle_read	; Read stream
	movx	@r1, a		; Write byte to output
	inc	r1
	mov	r4, a		; last = data
decompress_srle_l2:
	call	decompress_srle_read	; Read stream
	mov	r0, a
	xrl	a, r4		; if (last == data) repeat
	jz	decompress_srle_repeat
	mov	a, r0
	movx	@r1, a		; Write byte to output
	inc	r1
	mov	r4, a		; last = data
	djnz	r6, decompress_srle_l2
	sel	rb1
	ret

decompress_srle_repeat:
	call	decompress_srle_read	; Read stream
	dec	a
	jz	decompress_srle_repeat_l2
	mov	r5, a
	mov	a, r0
decompress_srle_repeat_l1:
	movx	@r1, a		; Write byte to output
	inc	r1
	djnz	r5, decompress_srle_repeat_l1
decompress_srle_repeat_l2:
	djnz	r6, decompress_srle_l1
	sel	rb1
	ret

decompress_srle_read:
	clr	a
	mov	psw, a		; stack=0, ret gets stack 7
	mov	a, r7
	inc	r7		; a = index++
	ret			; Read from tc
decompress_srle_return:
	xch	a, r2
	mov	psw, a		; Restore PSW
	xch	a, r2
	ret
